Bug 1305382 - Review Request: tristripper - Triangle stripification (algorithm by Tanguy Fautre)
Review Request: tristripper - Triangle stripification (algorithm by Tanguy Fa...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Denis Fateyev
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1305390
  Show dependency treegraph
 
Reported: 2016-02-07 15:54 EST by Raphael Groner
Modified: 2016-03-31 20:26 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-31 20:26:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
denis: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Raphael Groner 2016-02-07 15:54:25 EST
Spec URL: https://raphgro.fedorapeople.org/review/chess/dreamchess/tristripper.spec
SRPM URL: https://raphgro.fedorapeople.org/review/chess/dreamchess/tristripper-1.10-1.fc23.src.rpm
Description: Triangle stripification (algorithm by Tanguy Fautré)
Fedora Account System Username: raphgro

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=12898920
Comment 1 Upstream Release Monitoring 2016-02-07 16:01:06 EST
raphgro's scratch build of tristripper-1.10-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12898920
Comment 2 Denis Fateyev 2016-02-09 11:28:40 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "zlib/libpng". 25 files have unknown
     license. Detailed output of licensecheck in
     /home/mock/sandbox/review/1305382-tristripper/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: tristripper-1.10-1.fc23.x86_64.rpm
          tristripper-devel-1.10-1.fc23.x86_64.rpm
          tristripper-debuginfo-1.10-1.fc23.x86_64.rpm
          tristripper-1.10-1.fc23.src.rpm
tristripper.x86_64: W: no-documentation
tristripper-devel.x86_64: W: only-non-binary-in-usr-lib
tristripper-devel.x86_64: W: no-documentation
tristripper.src:48: W: macro-in-comment %{name}
4 packages and 0 specfiles checked; 0 errors, 4 warnings.


Rpmlint (debuginfo)
-------------------
Checking: tristripper-debuginfo-1.10-1.fc23.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
tristripper-devel.x86_64: W: only-non-binary-in-usr-lib
tristripper-devel.x86_64: W: no-documentation
tristripper.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libtristripper.so.1.10 /lib64/libm.so.6
tristripper.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 4 warnings.


Requires
--------
tristripper-devel (rpmlib, GLIBC filtered):
    libtristripper.so.1()(64bit)
    tristripper(x86-64)

tristripper-debuginfo (rpmlib, GLIBC filtered):

tristripper (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
tristripper-devel:
    tristripper-devel
    tristripper-devel(x86-64)

tristripper-debuginfo:
    tristripper-debuginfo
    tristripper-debuginfo(x86-64)

tristripper:
    libtristripper.so.1()(64bit)
    tristripper
    tristripper(x86-64)



Source checksums
----------------
https://github.com/spoonless/tristripper/archive/v1.10.tar.gz#/tristripper-1.10.tar.gz :
  CHECKSUM(SHA256) this package     : 24afdc2b65ca40a4f4b54589f17d30d78a8749cddb475bbe44bfc8906183753c
  CHECKSUM(SHA256) upstream package : 24afdc2b65ca40a4f4b54589f17d30d78a8749cddb475bbe44bfc8906183753c


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1305382
Buildroot used: fedora-23-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Remarks:
--------
1) If you're planning to provide the package for epel7 or older Fedora versions, `%global _hardened_build 1` is required. Recent Fedoras though don't need it anymore;

2) Please add all BRs: coreutils, gcc-c++, sed;

3) README.md isn't a pure license; it can be simply in `%doc`;

4) Please use a sane description for `devel` subpackage. At least, "This package contains the header files and libraries for developing with %{name}." or whatever you'd like to use for this package;

5) What's wrong with tests? Are they provided?

6) Better get rid of macros in comments to eliminate rpmlint warnings.
Comment 3 Raphael Groner 2016-02-11 08:33:38 EST
Hi Denis,

thanks for the review and your feedback.

> Remarks:
> --------
> 1) If you're planning to provide the package for epel7 or older Fedora 
> versions, `%global _hardened_build 1` is required. Recent Fedoras though don't 
> need it anymore;
Currently, I do not see any need for EPEL or older Fedoras. This package is dedicated to developers that want to enhance dreamchess with extensions, though upstream does not provide any user documentation - may be worth an issue to report.

2) Please add all BRs: coreutils, gcc-c++, sed;
Not a good idea IMHO. You can expect everything being installed that rpm depends on. As bash (and mock installing bash) depends on coreutils' functionality and rpm package depends on it, we can guess a functional build environment when rpm is installed by rpmbuild.
https://lists.fedoraproject.org/pipermail/devel/2015-June/211423.html

3) README.md isn't a pure license; it can be simply in `%doc`;

4) Please use a sane description for `devel` subpackage. At least, "This package contains the header files and libraries for developing with %{name}." or whatever you'd like to use for this package;
Fixed. Links are the same.

5) What's wrong with tests? Are they provided?
OpenGL can not work with framebuffer of a virtual Xorg in mock/koji. No idea how to fix.
# libGL error: No matching fbConfigs or visuals found
# libGL error: failed to load driver: swrast

6) Better get rid of macros in comments to eliminate rpmlint warnings.
That's intentional as a reminder cause of the failing tests and should not harm on koji for the official builds, see above.
Comment 4 Raphael Groner 2016-02-11 08:35:18 EST
> 3) README.md isn't a pure license; it can be simply in `%doc`;
Couriously enough, README.md includes the license text for this package, so I decided to use that file for %license.
Comment 5 Denis Fateyev 2016-02-11 09:13:04 EST
(In reply to Raphael Groner from comment #3)
>> 2) Please add all BRs: coreutils, gcc-c++, sed;
> Not a good idea IMHO. You can expect everything being installed that rpm
> depends on. As bash (and mock installing bash) depends on coreutils'
> functionality and rpm package depends on it, we can guess a functional build
> environment when rpm is installed by rpmbuild.
> https://lists.fedoraproject.org/pipermail/devel/2015-June/211423.html

Well, for all the details, just in case:
 - if you follow the fpc ticked mentioned, you'll see the latest writeup: https://fedorahosted.org/fpc/ticket/540#comment:26
which leads to: https://fedoraproject.org/wiki/Packaging:C_and_C%2B%2B?rd=C_and_C which requires `gcc-c++`;
 - for `coreutils`:
 > You can expect everything being installed that rpm depends on.
 we shouldn't expect that the current build procedure along the dependencies won't be changed ever. Better not to rely on inter-package deps that *currently* present in buildroot but point `coreutils` BR explicitly if we use its functionality in this very spec.
 - for `sed`: it should be used, seems there's no doubt. 

>> 3) README.md isn't a pure license; it can be simply in `%doc`;
> Couriously enough, README.md includes the license text for this package,
> so I decided to use that file for %license.

Yeah, but it also contain some common information about the package.
Generally speaking, it's not that strange to meet README file with license in `%doc` (like older Redora/RH distributions always did), but a bit uncommon to have general instructions in `%license`. Better solution would be split license and README into appropriate files, but meanwhile I believe that `%doc` would be a better location here.

>> 6) Better get rid of macros in comments to eliminate rpmlint warnings.
> That's intentional as a reminder cause of the failing tests and should not
> harm on koji for the official builds, see above.

Well, it's up to you and actually doesn't break things; but I would unwrap %{name} just to eliminate warnings.
Comment 6 Raphael Groner 2016-02-11 09:40:32 EST
Hmm, zodbot can't process bug titles with unicode.
Comment 7 Denis Fateyev 2016-02-23 12:03:20 EST
Any progress with it?
Comment 8 Raphael Groner 2016-02-23 14:50:37 EST
Sorry for no feedback. I am currently working on other major bugs in rawhide that eats all my spare time I can offer. This review has to wait.
Comment 9 Raphael Groner 2016-02-27 14:28:30 EST
Sorry for my long delay of a response. We'd severe issues in rawhide cause of the gcc6 mass rebuild, that must be handled with absolute priority.

1a I can not confirm about coreutils. Responsible people from FPC tell me that dependencies are to be considered as good if a package builds in mock and mock installs base environment incl. coreutils.

1b Okay, I can add BR: gcc-c++, just to be sure not to use an alternative like clang.

2 Okay also about adding BR: sed, if you really insist on that.

3 That's in responsibility of upstream to provide a good license text file, at least if zlib/libpng tells so, not sure. But I can remove %license, okay.

6 There's really not any relevance for the review process with those rpmlint warnings about macros in comments. TBH, I do not even know why it warns at all.
Comment 10 Raphael Groner 2016-02-27 14:39:19 EST
Spec URL: https://raphgro.fedorapeople.org/review/chess/dreamchess/tristripper.spec
SRPM URL: https://raphgro.fedorapeople.org/review/chess/dreamchess/tristripper-1.10-2.fc23.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=13152021

%changelog
* Sat Feb 27 2016 Raphael Groner <> - 1.10-2
- add build needs, remove license macro and use license text as documentation
Comment 11 Upstream Release Monitoring 2016-02-27 14:45:06 EST
raphgro's scratch build of tristripper-1.10-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13152021
Comment 12 Denis Fateyev 2016-02-27 15:50:00 EST
(In reply to Raphael Groner from comment #9)
> Sorry for my long delay of a response. We'd severe issues in rawhide cause
> of the gcc6 mass rebuild, that must be handled with absolute priority.

No problem ;-)

> 1a I can not confirm about coreutils. Responsible people from FPC tell me
> that dependencies are to be considered as good if a package builds in mock
> and mock installs base environment incl. coreutils.

In general, yes, it's hard to realize that mock would go without coreutils.
Though the tendency is that even many base packages that previously were in the exception list now according the policy should be mentioned in BR. Like gcc-c++ we're discussing below.

This aspect about `coreutils` presence in BRs always raises questions, and some maintainers currently use it (like we in "perl-sig" do), other don't. I'm not actually insisting on coreutils in this case.

> 2 Okay also about adding BR: sed, if you really insist on that.

Unlike coreutils, it's a must since neither coreutils nor gcc-c++ nor bash have "sed" in requires. Without that "exception list" its position is a bit vague. 

> 3 That's in responsibility of upstream to provide a good license text file

Sure thing. But you can ping them to do so, quite often upstreams are interested in fixing their things, and even do it in a timely manner ;-)

> 6 There's really not any relevance for the review process with those rpmlint
> warnings about macros in comments. TBH, I do not even know why it warns at
> all.

It eliminates the whole amount of warnings, so the package looks neat. Although, this very case with commented macros is optional.

As for the package description, it's also recommended to replace the French acute letter there with the common "e".

Otherwise the package is APPROVED.
Comment 13 Raphael Groner 2016-02-27 16:00:08 EST
(In reply to Denis Fateyev from comment #12)
…
> As for the package description, it's also recommended to replace the French
> acute letter there with the common "e".

Well, I changed in title for a similiar reason. I'll do also in description with the final package commit.

> Otherwise the package is APPROVED.

Thanks for the review!
Comment 14 Gwyn Ciesla 2016-02-28 19:05:30 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/tristripper
Comment 15 Rex Dieter 2016-03-08 14:32:16 EST
This is needed by bug #1305390 , why delay in building it?
Comment 16 Raphael Groner 2016-03-21 12:54:35 EDT
(In reply to Rex Dieter from comment #15)
> This is needed by bug #1305390 , why delay in building it?

The build is not delayed:

tristripper-1.10-2.fc24 	raphgro 	2016-02-29 11:20:37 	complete
tristripper-1.10-2.fc25 	raphgro 	2016-02-29 10:45:03 	complete

If you wonder about RELEASE_PENDING: I want to delay bodhi updates till we finish the review in bug #1305390 and provide both packages builds bundled as one update. Currently, there's no obvious need for tristripper other than for dreamchess-tools.
Comment 17 Rex Dieter 2016-03-21 12:58:46 EDT
Ah, ok, I failed to check koji (only to see if it was available in repos at the time, or maybe only f23, can't remember... and doesn't matter).  Thanks.
Comment 18 Fedora Update System 2016-03-22 19:01:54 EDT
dreamchess-tools-0-0.2.20141101gitf8f32aa.fc23 tristripper-1.10-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0b0250e202
Comment 19 Fedora Update System 2016-03-23 21:53:05 EDT
dreamchess-tools-0-0.2.20141101gitf8f32aa.fc23, tristripper-1.10-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0b0250e202
Comment 20 Fedora Update System 2016-03-31 20:26:41 EDT
dreamchess-tools-0-0.2.20141101gitf8f32aa.fc23, tristripper-1.10-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.